/******************************************************************************
**
** AirIDS:
**    a wireless (802.11) intrusion detection system.
**
** actions.c
**
*************
**
** Copyright (c) 2001 all rights reserved, by Michael Lynn 
**
** Author: Michael Lynn abaddon@bsd.sh
**
** NOTES:
** this is still very very beta, use at your own risk...
** also most of this code is going to change soon...
** so if you dont like it bitch and ill fix the part your 
** bitching about...maybe...
**
** there is still lots more to come...
**
******************************************************************************/

#include <sys/types.h>
#include <asm/types.h>
#include <linux/types.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>


#define __ACTIONSC__

#include "actions.h"
#include "80211.h"
#include "80211_strings.h"
#include "filter_engine.h"



/*** Prototypes ***/

void *action_init_noargs (char *);
void *action_init_setname (char *);
void action_shutdown_null (void);
int action_frame_info (__u8 *, size_t, void *);
int action_add_mac1 (__u8 *, size_t, void *);
int action_add_mac2 (__u8 *, size_t, void *);
int action_add_mac3 (__u8 *, size_t, void *);
int action_add_mac4 (__u8 *, size_t, void *);
int action_add_src (__u8 *, size_t, void *);
int action_remove_member (__u8 *, size_t, void *);
int action_ignore (__u8 *, size_t, void *);
int action_ignore_set (__u8 *, size_t, void *);
extern int action_insert_text (__u8 *, size_t, void *);

extern rule_set_t *find_set (const char *);
extern char *skip_whitespace (char *);
extern char *find_whitespace (char *);
extern int has_member (__u8 *, rule_set_t *);
extern __u8 *get_src_mac (__u8 *, size_t);
extern int add_member (__u8 *, rule_set_t *);
extern void remove_member (__u8 *, rule_set_t *);

/******************/



/*** Globals ***/

/* list of valid actions and their callbacks */
struct actions	action_list[NUM_ACTIONS] = {
    {"console_print_frame", action_frame_info, action_init_noargs, action_shutdown_null, 0}, 
    {"print_frame", action_insert_text, action_init_noargs, action_shutdown_null, 0},
    {"add_mac1", action_add_mac1, action_init_setname, action_shutdown_null, 0},
    {"add_mac2", action_add_mac2, action_init_setname, action_shutdown_null, 0},
    {"add_mac3", action_add_mac3, action_init_setname, action_shutdown_null, 0},
    {"add_mac4", action_add_mac4, action_init_setname, action_shutdown_null, 0},
    {"add_src", action_add_src, action_init_setname, action_shutdown_null, 0},
    {"remove_member", action_remove_member, action_init_setname, action_shutdown_null, 0},
    {"ignore", action_ignore, action_init_noargs, action_shutdown_null, 0},
    {"ignore_set", action_ignore_set, action_init_noargs, action_shutdown_null, 0}
};



/***************/


/*
 * this is a dummy action init, for actions with no args...
 * it just makes sure there are no args given to the action...
 */
void *action_init_noargs (char *args)
{
    char *token;


    token = skip_whitespace(args);
    if(*token != '\0') {
        fprintf(stderr, "Parse error: action expected no arguements, to many given.\n");
        exit(1);
    }

    return(NULL);
}


/*
 * init/syntax checking function for all that take a setname as 
 * the arguement...
 */
void *action_init_setname (char *args)
{
    char		*token, *ptr;
    rule_set_t	*set;


    token = skip_whitespace(args);
    ptr = find_whitespace(token);
    ptr = skip_whitespace(ptr);
    if(*ptr != '\0') {
        fprintf(stderr, "Parse error: action expected a set name as an arguement.\n");
        exit(1);
    }

    if((set = find_set(token)) == NULL) {
        fprintf(stderr, "Parse error: invalid set \"%s\" refferenced as action arguement.\n", args);
        exit(1);
    }

    return((void *)set);
}


/*
 * this is a dummy action shutdown function, it just returns...
 */
void action_shutdown_null (void)
{
    return;
}


/*
 * this action prints out some info on the frame...
 * ment mostly for debugging...
 * right now it only prints out frames using the
 * a3 header, and then interprets them all as that...
 */
int action_frame_info (__u8 *frame, size_t buflen, void *arg)
{
    int				i;
    struct a3_80211	*mac_hdr = (struct a3_80211 *)frame;


    if(buflen < sizeof(struct a3_80211)) 
        return(ACTION_ERROR);
    /* ok we found one, for now just output the Mac Header */
    printf("\nframe length =\t%u\n", buflen);
    printf("\tversion =\t%hx\n", mac_hdr->mh_version);
    printf("\ttype =\t\t%s\n", frame_types[mac_hdr->mh_type]);
    printf("\tsubtype =\t%s\n", frame_subtypes[mac_hdr->mh_type][mac_hdr->mh_subtype]);
    printf("\tto_ds =\t\t%hx\n", mac_hdr->mh_to_ds);
    printf("\tfrom_ds =\t%hx\n", mac_hdr->mh_from_ds);
    printf("\tmore_frag =\t%hx\n", mac_hdr->mh_more_frag);
    printf("\tretry =\t\t%hx\n", mac_hdr->mh_retry);
    printf("\tpwr_man =\t%hx\n", mac_hdr->mh_pwr_man);
    printf("\tmore_data =\t%hx\n", mac_hdr->mh_more_data);
    printf("\twep =\t\t%hx\n", mac_hdr->mh_wep);
    printf("\torder =\t\t%hx\n", mac_hdr->mh_order);
    printf("\tda =\t\t");
    for(i=0;i < 6;i++) {
        printf("%hx ", mac_hdr->mh_da[i]);
    }
    printf("\n");
    printf("\tsa =\t\t");
    for(i=0;i < 6;i++) {
        printf("%hx ", mac_hdr->mh_sa[i]);
    }
    printf("\n");
    fflush(stdout);
    return(ACTION_SUCCESS);
}


/*
 * adds the mac1 to the set in the arg...
 */
int action_add_mac1 (__u8 *frame, size_t buflen, void *arg)
{
    __u8			mac[MAC_ADDR_LEN];
    struct a1_80211	*mac_hdr = (struct a1_80211 *)frame;
    rule_set_t		*set = (rule_set_t *)arg;


    if(buflen < sizeof(struct a1_80211)) {
        return(ACTION_ERROR);
    }

    memcpy(mac, mac_hdr->mh_mac1, MAC_ADDR_LEN);

    if(has_member(mac, set)) {
        return(ACTION_SUCCESS);
    }

    if(!add_member(mac, set)) {
        return(ACTION_FATAL);
    }

    return(ACTION_SUCCESS);
}


/*
 * adds the mac2 to the set in the arg...
 */

int action_add_mac2 (__u8 *frame, size_t buflen, void *arg)
{
    __u8			mac[MAC_ADDR_LEN];
    struct a2_80211	*mac_hdr = (struct a2_80211 *)frame;
    rule_set_t		*set = (rule_set_t *)arg;


    if(buflen < sizeof(struct a2_80211)) {
        return(ACTION_ERROR);
    }

    memcpy(mac, mac_hdr->mh_mac2, MAC_ADDR_LEN);

    if(has_member(mac, set)) {
        return(ACTION_SUCCESS);
    }

    if(!add_member(mac, set)) {
        return(ACTION_FATAL);
    }

    return(ACTION_SUCCESS);
}


/*
 * adds the mac3 to the set in the arg...
 */
int action_add_mac3 (__u8 *frame, size_t buflen, void *arg)
{
    __u8			mac[MAC_ADDR_LEN];
    struct a3_80211	*mac_hdr = (struct a3_80211 *)frame;
    rule_set_t		*set = (rule_set_t *)arg;


    if(buflen < sizeof(struct a3_80211)) {
        return(ACTION_ERROR);
    }

    memcpy(mac, mac_hdr->mh_mac3, MAC_ADDR_LEN);

    if(has_member(mac, set)) {
        return(ACTION_SUCCESS);
    }

    if(!add_member(mac, set)) {
        return(ACTION_FATAL);
    }

    return(ACTION_SUCCESS);
}


/*
 * adds the mac4 to the set in the arg...
 */
int action_add_mac4 (__u8 *frame, size_t buflen, void *arg)
{
    __u8			mac[MAC_ADDR_LEN];
    struct a4_80211	*mac_hdr = (struct a4_80211 *)frame;
    rule_set_t		*set = (rule_set_t *)arg;


    if(buflen < sizeof(struct a4_80211)) {
        return(ACTION_ERROR);
    }

    memcpy(mac, mac_hdr->mh_mac4, MAC_ADDR_LEN);

    if(has_member(mac, set)) {
        return(ACTION_SUCCESS);
    }

    if(!add_member(mac, set)) {
        return(ACTION_FATAL);
    }

    return(ACTION_SUCCESS);
}


/*
 * action to add a the src mac to a set...
 */
int action_add_src (__u8 *frame, size_t buflen, void *arg)
{
    __u8			*mac;
    rule_set_t		*set = (rule_set_t *)arg;


    if(buflen < sizeof(struct a4_80211)) {
        return(ACTION_ERROR);
    }

    if((mac = get_src_mac(frame, buflen)) == NULL) {
        return(ACTION_ERROR);
    }

    if(has_member(mac, set)) {
        return(ACTION_SUCCESS);
    }

    if(!add_member(mac, set)) {
        return(ACTION_FATAL);
    }

    return(ACTION_SUCCESS);
}


/*
 * action to remove a member from a set...
 */
int action_remove_member (__u8 *frame, size_t buflen, void *arg)
{
    __u8		*mac;
    rule_set_t		*set = (rule_set_t *)arg;


    if((mac = get_src_mac(frame, buflen)) == NULL) {
        return(ACTION_ERROR);
    }

    if(!has_member(mac, set)) {
        return(ACTION_ERROR);
    }

    remove_member(mac, set);

    return(ACTION_SUCCESS);
}


/*
 * this action just returns ACTION_IGNORE...
 */
int action_ignore (__u8 *frame, size_t buflen, void *args)
{
    return(ACTION_IGNORE);
}


/*
 * this action just returns ACTION_SETIGNORE...
 */
int action_ignore_set (__u8 *frame, size_t buflen, void *args)
{
    return(ACTION_SETIGNORE);
}


