/******************************************************************************
**
** AirIDS:
**    a wireless (802.11) intrusion detection system.
**
** filter_engine.c
**
*************
**
** Copyright (c) 2001 all rights reserved, by Michael Lynn 
**
** Author: Michael Lynn abaddon@bsd.sh
**
** NOTES:
** this is still very very beta, use at your own risk...
** also most of this code is going to change soon...
** so if you dont like it bitch and ill fix the part your 
** bitching about...maybe...
**
** there is still lots more to come...
**
******************************************************************************/


#include <sys/types.h>
#include <asm/types.h>
#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <string.h>

#include "filter_engine.h"
#include "actions.h"
#include "80211.h"


/*** Prototypes ***/

static int test_rule (__u8 *, size_t, struct test_expr *);
static __u16 hash_key (__u8 *, size_t keylen);
int has_member (__u8 *, rule_set_t *);
int add_member (__u8 *, rule_set_t *);
void remove_member (__u8 *, rule_set_t *);
rule_set_t *add_set (const char *);
void add_rule (rule_set_t *, filter_rule_t *);
__u8 *get_src_mac (__u8 *, size_t);
void process_frame (__u8 *, size_t);

/******************/


/*** Globals ***/

rule_set_t				rule_sets;	/* the wild card set and the head of the set list */
	
/***************/


/*
 * tests a given group of rules against the frame...
 * returns an apropriate truth value...
 * recursively calls itself until it walks the entire
 * tree of rule groupings...
 */
static int test_rule (__u8 *frame, size_t buflen, struct test_expr *test)
{
    unsigned int	truth_val = 0;		
    __u8			test_val[test->size];	/* pointer to test value in frame */
    __u8			*mac;


    /* NULL val indicates all frames should match */
    if(test->val == NULL) {
        return(1);
    } 

    /* if the buflen is smaller than the rule test val offset */
    if((buflen >= (test->offset + test->size)) || (test->size == 0)) {

        memcpy(test_val, (frame + test->offset), test->size);
        /* apply the mask, if any */
        if(test->size == 1) {
            if(test->mask != 0) {
                test_val[0] &= test->mask;
            }
        }

        /* which operator to use */
        switch(test->op) {
            case EQUAL_TO:
                if(!bcmp(test_val, test->val, test->size)) {
                    truth_val = 1;
                }
                break;
            case NOT_EQUAL_TO:
                if(bcmp(test_val, test->val, test->size)) {
                    truth_val = 1;
                }
                break;
            case GREATER_THAN:
                /* gcc supports only a long long the most we can test is a __u64 */
                switch(test->size) {
                    case U8:
                        if((*(__u8 *)(test_val)) > (*(__u8 *)(test->val)) ) {
                            truth_val = 1;
                        }
                        break;
                    case U16:
                        if((*(__u16 *)(test_val)) > (*(__u16 *)(test->val))) {
                            truth_val = 1;
                        }
                        break;
                    case U32:
                        if((*(__u32 *)(test_val)) > (*(__u32 *)(test->val))) {
                            truth_val = 1;
                        }
                        break;
                    case U64:
                        if((*(__u64 *)(test_val)) > (*(__u64 *)(test->val))) {
                            truth_val = 1;
                        }
                        break;
                    default:
                        break;
                }
                break;
            case LESS_THAN:
                /* gcc supports only a long long the most we can test is a __u64 */
                switch(test->size) {
                    case U8:
                        if((*(__u8 *)(test_val)) < (*(__u8 *)(test->val))) {
                            truth_val = 1;
                        }
                        break;
                    case U16:
                        if((*(__u16 *)(test_val)) < (*(__u16 *)(test->val))) {
                            truth_val = 1;
                        }
                        break;
                    case U32:
                        if((*(__u32 *)(test_val)) < (*(__u32 *)(test->val))) {
                            truth_val = 1;
                        }
                        break;
                    case U64:
                            if((*(__u64 *)(test_val)) < (*(__u64 *)(test->val))) {
                                truth_val = 1;
                            }
                            break;
                    default:
                        break;
                }
                break;
            case IN_SET:
                if((mac = get_src_mac(frame, buflen)) == NULL) {
                    break;
                }

                if(has_member(mac, (rule_set_t *)test->val)) {
                    truth_val = 1;
                }
                break;
            case NOT_IN_SET:
                if((mac = get_src_mac(frame, buflen)) == NULL) {
                    truth_val = 1;
                    break;
                }

                if(!has_member(mac, (rule_set_t *)test->val)) {
                    truth_val = 1;
                }
                break;
            default:
                /* must be some wack operator */
                truth_val = 0;
                break;
        }
    }


    /* the order here is important */
    if(test->high_expr != NULL) {
        if(test->high_op == OP_AND) {
            if(truth_val) {
                truth_val &= test_rule(frame, buflen, test->high_expr);
            }
        } else {
            if(!truth_val) {
                truth_val |= test_rule(frame, buflen, test->high_expr);
            }
        }
    }

    if(test->even_expr != NULL) {
        if(test->even_op == OP_AND) {
            if(truth_val) {
                truth_val &= test_rule(frame, buflen, test->even_expr);
            }
        } else {
            if(!truth_val) {
                truth_val |= test_rule(frame, buflen, test->even_expr);
            }
        }
    }

    /* lower paren depth groupings should always be linked to the start of a grouping */
    if(test->low_expr != NULL) {
        if(test->low_op == OP_AND) {
            if(truth_val) {
                truth_val &= test_rule(frame, buflen, test->low_expr);
            }
        } else {
            if(!truth_val) {
                truth_val |= test_rule(frame, buflen, test->low_expr);
            }
        }
    }
    
    return(truth_val);
}


/*
 * hashing function, returns a key less than HASH_SIZE...
 * keylen must be > 0...
 */
static __u16 hash_key (__u8 *key, size_t keylen) 
{
    register __u16	h = key[0];
    register int	i;

    for(i=0;i < keylen;i++) {
        h = ((h * 32) + key[i]) % HASH_SIZE;
    }
    return(h);
}


/*
 * tests to see if the given set has the given mac as a member...
 */
int has_member (__u8 *mac_addr, rule_set_t *set)
{
    set_member_t	*member;

    /* account for the wildcard set */
    if(set == &rule_sets) {
        return(1);
    }

    member = &set->members[hash_key(mac_addr, MAC_ADDR_LEN)];

    if(!member->used) {
        return(0);
    } else {
        do {
            if(!bcmp(member->mac_addr, mac_addr, MAC_ADDR_LEN)) {
                return(1);
            }
            member = member->collition;
        } while(member != NULL);
    }
    return(0);
}


/*
 * adds a mac to a given set, if there is a collition in
 * the hash table then it dynamicly allocates a new member
 * structure and adds it to the list...
 * WARNING this does NOT check to see if the mac is already
 * a member...
 * returns 0 on ENOMEM...
 */
int add_member (__u8 *mac_addr, rule_set_t *set)
{
    __u16	hashkey = hash_key(mac_addr, MAC_ADDR_LEN);

    if(!set->members[hashkey].used) {
        memcpy(set->members[hashkey].mac_addr, mac_addr, MAC_ADDR_LEN);
        set->members[hashkey].collition = NULL;
        set->members[hashkey].used = 1;
    } else {
        set_member_t	*new_member;

        if((new_member = (set_member_t *)malloc(sizeof(set_member_t))) == NULL) {
            return(0);
        }
        new_member->used = 1;
        memcpy(new_member->mac_addr, mac_addr, MAC_ADDR_LEN);
        new_member->collition = set->members[hashkey].collition;

        /* insert it into the list */
        set->members[hashkey].collition = new_member;
    }
    return(1);
}


/*
 * removes a member mac address from the given set
 * WARNING this does not check to see if it isnt in
 * the list...be careful...
 */
void remove_member (__u8 *mac_addr, rule_set_t *set)
{
    set_member_t	*member = &set->members[hash_key(mac_addr, MAC_ADDR_LEN)];

    if(member->collition == NULL) {
        member->used = 0;
    } else {
        do {
            if(!bcmp(member->collition->mac_addr, mac_addr, MAC_ADDR_LEN)) {
                set_member_t	*del = member->collition;

                member->collition = member->collition->collition;
                free(del);
                break;
            }
            member = member->collition;
        } while(member->collition != NULL);
    }
}


/*
 * adds a new state set into the master list...
 * returns a pointer to the new set...
 */
rule_set_t *add_set (const char *name)
{
    rule_set_t	*set, *list;


    if((set = (rule_set_t *)malloc(sizeof(rule_set_t))) == NULL) {
        return(NULL);
    }

    memset(set, 0, sizeof(rule_set_t));
    strncpy(set->setname, name, MAX_SETNAME);
    set->next_set = NULL;
    set->rules = NULL;

    /* goto the end of the list */
    list = &rule_sets;
    while(list->next_set != NULL) {
        list = list->next_set;
    }

    list->next_set = set;
    return(set);
}



/*
 * inserts the rule at the end of the rule list ...
 */
void add_rule (rule_set_t *set, filter_rule_t *rule) 
{
    filter_rule_t	*find = set->rules;

    /* goto the end of the list */
    if(find != NULL) {
        while(find->next_rule != NULL) {
            find = find->next_rule;
        }
        find->next_rule = rule;
    } else {
        set->rules = rule;
    }
}


/*
 * returns a pointer to the source mac address in the
 * given frame...
 */
__u8 *get_src_mac (__u8 *frame, size_t buflen)
{

    if(buflen < sizeof(struct a1_80211)) {
        errno = EINVAL;
        return(NULL);
    }

    switch (((struct a1_80211 *)frame)->mh_type) {
        case FC_TYPE_MGT:
            if(buflen < sizeof(struct a3_80211)) {
                errno = EINVAL;
                return(NULL);
            }
            return(((struct a3_80211 *)frame)->mh_mac2);
            break;
        case FC_TYPE_CTL:
            /* XXX - no real, but for DEMO ONLY */
            return(((struct a1_80211 *)frame)->mh_mac1);
            break;
        case FC_TYPE_DATA:
            if(buflen < sizeof(struct a4_80211)) {
                errno = EINVAL;
                return(NULL);
            }
            switch ((__u8)(((struct a1_80211 *)frame)->mh_to_ds | ((struct a1_80211 *)frame)->mh_from_ds)) {
                case 0:
                case 2:
                    return(((struct a4_80211 *)frame)->mh_mac2);
                    break;
                case 1:
                    return(((struct a4_80211 *)frame)->mh_mac3);
                    break;
                case 3:
                    return(((struct a4_80211 *)frame)->mh_mac4);
                    break;
            }
            break;
        case FC_TYPE_RESR:
            /* XXX - no real, but for DEMO ONLY */
            return(((struct a1_80211 *)frame)->mh_mac1);
            break;
    }

    /* never gets here */
    return(NULL);
}


/*
 * runs the test on the frame and then performs actions 
 * when warrented...
 */
void process_frame (__u8 *frame, size_t buflen)
{
    rule_set_t		*set = &rule_sets;
    filter_rule_t	*rule;
    __u8			*mac;
    int				action_return;


    if((mac = get_src_mac(frame, buflen)) == NULL) {
        return;
    }

    /* see run the rules for each set on this frame */
    do {
        if(has_member(mac, set) && (set->rules != NULL)) {
            rule = set->rules;
            do {
                if(test_rule(frame, buflen, rule->test_exprs)) {
                    action_return = rule->action(frame, buflen, rule->action_arg);

                    switch(action_return) {
                        case ACTION_FATAL:
                            /* XXX - you really should rapper this exit for lockings sake */
                            exit(1);
                            break;
                        case ACTION_ERROR:
                            /* XXX - make this do something meaningful */
                            break;
                        case ACTION_IGNORE:
                            /* XXX - this is a bit ugly but... */
                            return;
                            break;
                        case ACTION_SETIGNORE:
                            goto next_set;
                            break;
                        case ACTION_SUCCESS:	/* fall through */
                        default:
                            break;
                    }
                }
                rule = rule->next_rule;
            } while(rule != NULL);
        }
next_set:
        set = set->next_set;
    } while(set != NULL);
}


