/******************************************************************************
**
** AirIDS:
**    a wireless (802.11) intrusion detection system.
**
** preprocessor.c
**
*************
**
** Copyright (c) 2001 all rights reserved, by Michael Lynn 
**
** Author: Michael Lynn abaddon@bsd.sh
**
** NOTES:
** this is still very very beta, use at your own risk...
** also most of this code is going to change soon...
** so if you dont like it bitch and ill fix the part your 
** bitching about...maybe...
**
** there is still lots more to come...
**
** Known Bugs:
** File include recursion will not be pretty im sure...
**
******************************************************************************/

#include <sys/types.h>
#include <sys/stat.h>
#include <stdio.h>
#include <unistd.h>
#include <stdlib.h>
#include <fcntl.h>
#include <string.h>
#include <errno.h>

#include "preprocessor.h"


/* #define PP_DEBUG */


/*** Prototypes ***/

static void report_error (const char *, int, char *);
static char *skip_line (char *);
size_t preprocessor (char **, ssize_t);
static size_t strip_comments (char *, size_t);
static size_t do_file_include (char *, char **, size_t);
static char *find_file_include (char *);
static char *expression_start (char *, char *);
static size_t do_inline_include (char *, char **, size_t);
static char *find_inline_include (char *);
static size_t process_file_includes (char **, size_t);
static size_t process_inline_includes (char **, size_t);
extern char *skip_whitespace (char *);
extern char *get_token (char **);

/******************/


/*
 * writes and error message to stderr and exits...
 */
static void report_error (const char *message, int linenum, char *line)
{
    char	*end;

    if((end = strchr(line, '\n')) != NULL) {
        *end = '\0';
    }

    if(linenum > 0) {
        fprintf(stderr, "%s: line number %u :\n%s\n", message, linenum, line);
    } else {
        fprintf(stderr, "%s: line number unknown :\n%s\n", message, line);
    }

    exit(1);
}


static char *skip_line (char *string)
{
    char	*ptr = string;


    if((ptr = strchr(ptr, '\n')) == NULL) {
        return(NULL);
    } 

    if(*(++ptr) == '\0') {
        return(NULL);
    }
    return(ptr);     
}


/*
 * strips the buffer of all comments and empty lines (lines 
 * containing only whitespace...returns the new size of the 
 * buffer...this function does not fail...
 */
static size_t strip_comments (char *buf, size_t buflen)
{
    register char	*ptr, *test;
    size_t			newlen;

    ptr = buf;
    newlen = buflen;


    /* check to see if the buf is empty */
    if(ptr == '\0') {
        return(0);
    }

    while(ptr < (buf + newlen)) {

        if((test = skip_whitespace(ptr)) == NULL) {
            *ptr = '\0';
            break;
        }

        memmove(ptr, test, (newlen - (test - buf)));
        newlen -= (test - ptr);

        test = skip_line(ptr);
        
        if(*ptr == CHR_COMMENT) {
            if(test == NULL) {
                *ptr = '\0';
                break;
            }
            memmove(ptr, test, (newlen - (test - buf)));
            newlen -= (test - ptr);
        } else {
            if(test == NULL) {
                break;
            }
            ptr = test;
        }
    }

    
    *(buf + newlen) = '\0';
    return(newlen);
}


/*
 * this is given the offset to the filename in the rules file
 * it then checks to see if it can open the file, opens it, 
 * reads its contents into a buffer, then it strips the comments
 * from that buffer and allocates a new buffer large enough to
 * hold the new combined buffer, bother include files buffers are
 * then free'ed and the passed buffer is changed to point to the
 * new combined buffer...
 *
 * this function exits with an error message if something goes 
 * wrong, and returns the size of the new buffer on success...
 */
static size_t do_file_include (char *filename, char **buf, size_t buflen)
{
    char		*ptr, *include, *new, *line;
    size_t		newlen, includelen;
    ssize_t		nbytes;
    int			fd;
    struct stat	st;



    /* we need to find the start of the line */
    line = filename;
    while(*(--line) != '%');

    filename = skip_whitespace(filename);

    memset(&st, 0, sizeof(struct stat));
    /* its safe to assume that this is good syntax */
    ptr = strchr(filename, '}');

    *ptr = '\0';
    if(stat(filename, &st) < 0) {
        fprintf(stderr, "Preprocessor error: file include\n%s\n", strerror(errno));
        exit(1);
    }

    if((fd = open(filename, O_RDONLY)) < 0) {
        fprintf(stderr, "Preprocessor error: file include\n%s\n", strerror(errno));
        exit(1);
    }

    *ptr = '}';

    if((include = (char *)malloc(st.st_size + 1)) == NULL) {
        fprintf(stderr, "Preprocessor error: file include\n%s\n", strerror(errno));
        exit(1);
    }

    includelen = st.st_size + 1;
    include[includelen - 1] = '\0';

    ptr = include;
    nbytes = st.st_size;
    do { 
        if((nbytes = read(fd, ptr, nbytes)) < 0) {
            if(errno == EINTR) {
                nbytes = 0;
                continue;
            }
            fprintf(stderr, "Preprocessor error: file include\n%s\n", strerror(errno));
            exit(1);
        }
        ptr = (ptr + nbytes);
        nbytes = st.st_size - nbytes;
    } while(nbytes != 0);
    close(fd);

    includelen = strip_comments(include, includelen);

    *line = '\0';
    newlen = strlen(*buf) + strlen(include) + 1;
    line = strchr(line + 1, '}');
    line++;
    if((ptr = strchr(line, '\n')) != NULL) {
        line = ptr + 1;
    }
    newlen += strlen(line);

    if((new = (char *)malloc(newlen)) == NULL) {
        fprintf(stderr, "Preprocessor error: file include\n%s\n", strerror(errno));
        exit(1);
    }
    new[newlen - 1] = '\0';

    strcpy(new, *buf);
    strcpy((new + strlen(*buf)), include);
    strcpy((new + strlen(*buf) + strlen(include)), line);
    free(include);
    free(*buf);
    *buf = new;

    return(newlen);
}


/*
 * this finds an instance of a file include expression in
 * the buffer, and returns a pointer to the start of the
 * filename... 
 * returns NULL if no file includes are found...
 */
static char *find_file_include (char *buf)
{
    char	*ptr = buf;

    if(*ptr == '\0') {
        return(NULL);
    }

    /* XXX - i probably should get rid of this infinate loop */
    while(1) {

        /* we can assume that no line starts with whitespace */
        if(!strncmp(ptr, "%include", strlen("%include"))) {
            ptr += strlen("%include");
            if((ptr = skip_whitespace(ptr)) != NULL) {
                if(*ptr == '{') {
                    char	*test;

                    /* ok this is an file include but is its syntax good? */
                    if((test = strchr(ptr, '}')) == NULL) {
                        report_error("Parse error: expected '}' ", -1, ptr);
                    } 
                    return(ptr + 1);
                } else {
                    report_error("Parse error: expected '{' ", -1, ptr);
                }
            }
        }

        if((ptr = skip_line(ptr)) == NULL) {
            break;
        }
    }

    return(NULL);
}


/*
 * finds the start of the current expresstion, starting at
 * the base and working backwards until it hits the top...
 * it will return either the first occurance of ';' directly
 * before the base, or top, if it hits that first...
 */
static char *expression_start (char *base, char *top)
{
    register char *ptr = base;


    while(ptr != top) {
        if(*ptr == ';') {
            break;
        }
        ptr--;
    }

    if((ptr + 1) < base) {
        if((*(++ptr) == '\n')) {
            ptr++;
        }
    }

    return(ptr);
}


/*
 * XXX - this function is too large and needs breaking up...
 * 
 * this opens the file the included file, reads in the tokens
 * and inserts them into a new buffer...it frees the old buffer
 * and replaces it...
 */
static size_t do_inline_include (char *filename, char **buf, size_t buflen)
{
    char			*new, *include, *ptr, *ptr2, *head, *tail, *top, *bottom;
    size_t			newlen, includelen;
    ssize_t			nbytes;
    int				fd;
    unsigned int	numtokens, i;
    struct stat		st;


    filename = skip_whitespace(filename);

    memset(&st, 0, sizeof(struct stat));

    /* its safe to assume that this is good syntax */
    ptr = strchr(filename, '}');

    *ptr = '\0';
    if(stat(filename, &st) < 0) {
        fprintf(stderr, "Preprocessor error: file include\n%s\n", strerror(errno));
        exit(1);
    }

    if((fd = open(filename, O_RDONLY)) < 0) {
        fprintf(stderr, "Preprocessor error: file include\n%s\n", strerror(errno));
        exit(1);
    }


    if((include = (char *)malloc(st.st_size + 1)) == NULL) {
        fprintf(stderr, "Preprocessor error: file include\n%s\n", strerror(errno));
        exit(1);
    }

    includelen = st.st_size + 1;
    include[includelen - 1] = '\0';

    ptr = include;
    nbytes = st.st_size;
    do { 
        if((nbytes = read(fd, ptr, nbytes)) < 0) {
            if(errno == EINTR) {
                nbytes = 0;
                continue;
            }
            fprintf(stderr, "Preprocessor error: file include\n%s\n", strerror(errno));
            exit(1);
        }
        ptr = (ptr + nbytes);
        nbytes = st.st_size - nbytes;
    } while(nbytes != 0);
    close(fd);

    /*
     * we will parse the rules buffer into 2 parts initialy...
     * we will then count the number of tokens in the included
     * file, with that we know how large the new buffer will be
     * we will malloc the buffer and copy the top to it, that 
     * will copy one copy of the head to the new buffer...we 
     * then will copy the first expanded expression and the last
     * manualy, the rest will be in a loop...
     */
    top = *buf;
    newlen = 3;	/* one for each null in it, or about to be... */

    head = expression_start(filename, top);

    ptr = strchr(head, '$');
    *ptr = '\0';

    newlen += strlen(top);

    numtokens = 0;
    ptr = include;
    tail = ptr;
    while((ptr = strchr(ptr, '\n')) != NULL) {
        *ptr = '\0';
        ptr++;
        numtokens++;
        newlen += strlen(tail);
        tail = ptr;
    }

    tail = filename + strlen(filename) + 1;
    if((bottom = strchr(tail, ';')) == NULL) {
        fprintf(stderr, "Parse error: expected ';' : line number unknown\n");
        exit(1);
    }

    *bottom = '\0';
    bottom++;

    /* we can now calculate newlen */
    newlen += strlen(bottom);
    newlen += (numtokens - 1)*strlen(head);
    newlen += (numtokens - 1)*(strlen(tail) + 1);

    if((new = (char *)malloc(newlen)) == NULL) {
        fprintf(stderr, "Preprocessor error: file include\n%s\n", strerror(errno));
        exit(1);
    }

    /* ok here we go, prey to the machine gods and this wont gpf */
    strcpy(new, top);

    /* let expand the expression */
    ptr = include;
    ptr2 = new + strlen(top);
    strcpy(ptr2, ptr);
    ptr += strlen(ptr) + 1;
    ptr2 += strlen(ptr);
    strcpy(ptr2, tail);
    ptr2 += strlen(tail);
    *(ptr2++) = ';';
    *(ptr2++) = '\n';
    for(i=0;i < (numtokens - 1);i++) {
        strcpy(ptr2, head);
        ptr2 += strlen(head);
        strcpy(ptr2, ptr);
        ptr2 += strlen(ptr);
        ptr += strlen(ptr) + 1;
        strcpy(ptr2, tail);
        ptr2 += strlen(tail);
        *(ptr2++) = ';';
        *(ptr2++) = '\n';
    }

    /* i dont want that extra \n, and im lazy */
    ptr2--;
    
    /* finaly copy the bottom */
    strcpy(ptr2, bottom);

    /* ok clean it all up and replace the old buffer */
    free(*buf);
    free(include);
    *buf = new;
    
    return(newlen);
}


/*
 * this searches the buffer for an inline file include
 * it checks its syntax, and returns a pointer to the
 * start of its filename...
 * it returns NULL if no inline file includes are found
 */
static char *find_inline_include (char *buf)
{
    char	*ptr, *test;

    ptr = buf;
    /* make sure be dont gpf if first byte is $ */
    if(*ptr != '$') {
        while((ptr = strchr(ptr, '$')) != NULL) {
            /* make sure its not escaped */
            if(*(ptr - 1) != '\\') {
                break;
            }
        }
    }

    if(ptr == NULL) {
        return(NULL);
    }

    if((test = skip_whitespace(ptr)) == NULL) {
        report_error("Parse error: unexpected end if file", -1, ptr);
    }

    if((test = strchr(test, '{')) == NULL) {
        report_error("Parse error: expected '{' ", -1, ptr);
    }

    ptr = test + 1;

    if((test = strchr(test, '}')) == NULL) {
        report_error("Parse error: expected '}' ", -1, ptr);
    }

    return(ptr);
}


/*
 * this will find all the file includes, expand them, and repeat
 * till all are included...
 */
static size_t process_file_includes (char **buf, size_t buflen)
{
    char	*line = *buf;
    size_t	newlen = buflen;


    while((line = find_file_include(line)) != NULL) {
        newlen = do_file_include(line, buf, newlen);
        line = *buf;
    }

    return(newlen);
}


/*
 * this will search for all the inline file includes, expand them
 * and repeat until it is finished...
 */
static size_t process_inline_includes (char **buf, size_t buflen)
{
    char	*line = *buf;
    size_t	newlen = buflen;


    while((line = find_inline_include(line)) != NULL) {
        newlen = do_inline_include(line, buf, newlen);
        line = *buf;
    }

    return(newlen);
}


/*
 * this pads whitespace around each parenthesis for
 * easier parsing of parenthetical groupsing of test 
 * expressions in the rules compiler propper...
 */
static size_t pad_parenthesis (char **buf, size_t buflen)
{
    char	*new, *ptr, *ptr2, *block;
    size_t	newlen, count;


    newlen = buflen;
    count = 0;
    ptr = *buf;
    
    if(*ptr == ')') {
        count += 2;
        ptr++;
    }

    while((ptr = strchr(ptr, ')')) != NULL) {
        if(*(ptr - 1) != '\\') {
            count += 2;
            ptr++;
        }
    }

    ptr = *buf;
    
    if(*ptr == '(') {
        count += 2;
        ptr++;
    }

    while((ptr = strchr(ptr, '(')) != NULL) {
        if(*(ptr - 1) != '\\') {
            count += 2;
            ptr++;
        }
    }

    /* 
     * this is a good time to do a quick test to
     * see if parenthesis match, though its important
     * to note that a talented idiot can still evade 
     * this quick test...
     */

    if((count % 2) != 0) {
        fprintf(stderr, "Warning: unmatched parenthesis, im sure you'll hear more about this before im done.\n");
    }

    newlen += count;

    if((new = (char *)malloc(newlen)) == NULL) {
        fprintf(stderr, "Fatal error: %s: unable to continue.\n", strerror(errno));
        exit(1);
    }
    memset(new, 0, newlen);


    ptr = *buf;
    block = *buf;
    ptr2 = new;

    if((*ptr == ')') || (*ptr == '(')) {
        *(ptr2++) = ' ';
        *(ptr2++) = *ptr;
        *(ptr2++) = ' ';
        ptr++;
    }


    while(*ptr != '\0') {
        if(*ptr == '(') {
            if(*(ptr - 1) != '\\') {
                *ptr = '\0';
                strcpy(ptr2, block);
                ptr2 += strlen(block);
                *(ptr2++) = ' '; 
                *(ptr2++) = '('; 
                *(ptr2++) = ' '; 
                block += strlen(block) + 1;
            }
        } else if(*ptr == ')') {
            if(*(ptr - 1) != '\\') {
                *ptr = '\0';
                strcpy(ptr2, block);
                ptr2 += strlen(block);
                *(ptr2++) = ' '; 
                *(ptr2++) = ')'; 
                *(ptr2++) = ' '; 
                block += strlen(block) + 1;
            }
        }
        ptr++;
    }

    strcpy(ptr2, block);


    free(*buf);
    *buf = new;

    return(newlen);
}


/*
 * removes comments, empty lines, expands macros, file includes, 
 * and inline file includes...
 * it reallocs the the input buffer to the correct size and then
 * it null terminates it and returns the new buffer size...
 * on a fatal error, it exits with verbose error reporting...
 */
size_t preprocessor (char **buf, ssize_t buflen)
{
    ssize_t	outlen;

    
    /* remove and blank lines from the file */
#ifdef PP_DEBUG
printf("raw:\n%s", *buf); fflush(stdout);
#endif 

    outlen = strip_comments(*buf, buflen);

#ifdef PP_DEBUG
printf("\n----\nstrip comments:\n%s", *buf); fflush(stdout);
#endif 

    outlen = process_file_includes(buf, outlen);

#ifdef PP_DEBUG
printf("\n----\nfile includes:\n%s", *buf); fflush(stdout);
#endif 

    outlen = process_inline_includes(buf, outlen);

#ifdef PP_DEBUG
printf("\n----\ninline includes:\n%s", *buf); fflush(stdout);
#endif 

    outlen = pad_parenthesis(buf, outlen);

#ifdef PP_DEBUG
printf("\n----\npad parenthesis (output):\n%s", *buf); fflush(stdout);
exit(0);
#endif 

    return(outlen);
}


