/******************************************************************************
**
** AirIDS:
**    a wireless (802.11) intrusion detection system.
**
** rules_compiler.c
**
*************
**
** Copyright (c) 2001 all rights reserved, by Michael Lynn 
**
** Author: Michael Lynn abaddon@bsd.sh
**
** NOTES:
** this is still very very beta, use at your own risk...
** also most of this code is going to change soon...
** so if you dont like it bitch and ill fix the part your 
** bitching about...maybe...
**
** there is still lots more to come...
**
** Known Bugs:
**  - extra arguements to defines are not detected properly and will 
**    screw things all up...
**
******************************************************************************/


#include <sys/types.h>
#include <asm/types.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <string.h>
#include <sys/stat.h>
#include <fcntl.h>
#include <limits.h>
#include <netinet/in.h>	/* for htons & htonl */
#include <limits.h>

#include "filter_engine.h"
#include "actions.h"
#include "rules_file.h"


/* #define RC_DEBUG */


/*** Prototypes ***/

char *skip_whitespace (char *);
static char *next_expression (char *);
char *find_whitespace (char *);
char *next_token (char *);
rule_set_t *find_set (const char *);
int string_to_mac (char *, __u8 *);
static void define_member (char *);
static int get_type(const char *);
static void define_lvalue (char *);
static void define_set (char *);
static void add_rule (rule_set_t *, filter_rule_t *);
static void process_define (char *);
static struct rule_lvalue *find_lvalue (char *);
static struct test_expr *parse_test_expr (char **);
static __u8 get_test_op (char **);
static struct test_expr *process_expr_layer (char **);
static filter_rule_t *process_test_exprs (char **);
static void process_rule (char *);
void load_rules_file (const char *);

extern int has_member (__u8 *, rule_set_t *);
extern int add_member (__u8 *, rule_set_t *);
extern rule_set_t *add_set (const char *);
extern size_t preprocessor (char **, ssize_t);

/******************/


/*** Globals ***/

static struct rule_lvalue	*lvalue_base = NULL;

extern rule_set_t		rule_sets;
extern struct actions	action_list[NUM_ACTIONS];	

/***************/



/*
 * skips all white space and returns a pointer to the next non
 * whitespace char in the null terminated array, returns NULL if
 * it hits the end of the string without finding non-whitespace 
 */
char *skip_whitespace (char *string)
{
    register char	*ptr = string;

    do{
        if((*ptr != ' ') && (*ptr != '\t') && (*ptr != '\n') && ((*ptr != '\r'))) {
            return(ptr);
        }
    } while(*(++ptr) != '\0');
    return(ptr);
}


/*
 * finds the end of the next expression, null terminates
 * it, and returns a pointer to its start...it advances 
 * buf to the next expression...
 * if the expression is of bad syntax it exits with an
 * error message...
 * returns NULL if this was the last expression...
 */
static char *next_expression (char *buf)
{
    char	*ptr, *start;

    start = skip_whitespace(buf);
    if(*start == '\0') {
        return(NULL);
    }

    if((ptr = strchr(start, CHR_ENDEXPR)) == NULL) {
        fprintf(stderr, "Parse error: expected ';'\n\"%s\"\n", buf);
        exit(1);
    }
    *ptr = '\0';

    return(start);
}


/*
 * returns a pointer to the next occurance of whitespace
 * returns a pointer to the end of string if null is found
 * first...
 */
char *find_whitespace (char *buf)
{
    register char	*ptr;

    ptr = buf;
    while((*ptr != '\0') && (*ptr != ' ') && (*ptr != '\t') && (*ptr != '\n') && (*ptr != '\r')) {
        ptr++;
    }
    
    return(ptr);
}


/*
 * finds the next token in the expression, returns a pointer
 * to its start...
 */
char *next_token (char *buf)
{
    char	*ptr, *start;

    
    start = buf + strlen(buf) + 1;
    start = skip_whitespace(start);
    if(*start == '\0') {
        return(NULL);
    }

    ptr = find_whitespace(start);
    
    *ptr = '\0';

    return(start);
}


/*
 * searches the linked list of sets for one with the
 * name setname, if it exists, a pointer to it is 
 * returned, if it does not, then NULL is returned...
 */
rule_set_t *find_set (const char *setname)
{
    rule_set_t	*sets = &rule_sets;

    do {
        if(!strcmp(sets->setname, setname)) {
            return(sets);
        }
        sets = sets->next_set;
    } while(sets != NULL);

    return(NULL);
}


/*
 * converts a string to a mac address...
 */
int string_to_mac (char *string, __u8 *mac_buf)
{
    char			*ptr, *next;
    unsigned long	val;
    int				i;


    ptr = next = string;
    for(i=0;i < MAC_ADDR_LEN;i++) {
        if((val = strtoul(next, &ptr, 16)) > 255) {
            return(-1);
        }
        mac_buf[i] = (__u8)val;
        if((next == ptr) && (i != MAC_ADDR_LEN - 1)) {
            return(-1);
        }
        next = ptr + 1;
    }

    /* make sure they didnt give us more then they should have */
    if((*next != '\0') && (*next != ' ') && (*next != '\t') && (*next != '\n') && (*next != '\r')) {
        return(-1);
    } 

    return(1);
}


/*
 * processes a member definition...
 * exits with error message on failure...
 */
static void define_member (char *expression)
{
    char		*token, *addr;
    rule_set_t	*set;
    __u8		mac[MAC_ADDR_LEN];

    
    if((token = next_token(expression)) == NULL) {
        fprintf(stderr, "Parse error: expected set name for member definition.\n");
        exit(1);
    }

    /* make sure its a good set... */
    if((set = find_set(token)) == NULL) {
        fprintf(stderr, "Parse error: \"%s\" is not a defined set, you must define it first.\n", token);
        exit(1);
    }

    if((token = next_token(token)) == NULL) {
        fprintf(stderr, "Parse error: member define: expected mac address.\n");
        exit(1);
    }

    if(string_to_mac(token, mac) < 0) {
        fprintf(stderr, "Parse error: badly formed mac address: \"%s\".\n", token);
        exit(1);
    }

    addr = token;
    
    /* make sure this isnt already a member */
    if(has_member(mac, set)) {
        fprintf(stderr, "Warning: member %s is redefined for set %s : ignoring duplicate.\n", token, set->setname);
        return;
    }
    
    if(!add_member(mac, set)) {
        fprintf(stderr, "Fatal error: %s: unable to continue.\n", strerror(errno));
        exit(1);
    }

    return;
}


/*
 * returns the int representation of the data type...
 */
static int get_type(const char *type)
{


    if(!strcmp(type, TS_U8)) {
        return(TN_U8);
    } else if(!strcmp(type, TS_U16)) {
        return(TN_U16);
    } else if(!strcmp(type, TS_U32)) {
        return(TN_U32);
    } else if(!strcmp(type, TS_HEX)) {
        return(TN_HEX);
    } else if(!strcmp(type, TS_STR)) {
        return(TN_STR);
    } else if(!strcmp(type, TS_MAC)) {
        return(TN_MAC);
    }
    return(-1);
}


/*
 * defines a new lvalue, it exits with a message on error
 * on success it will have added another lvalue to the 
 * linked list of valid lvalues...
 */
static void define_lvalue (char *expression)
{
    char				*token, *ptr;
    struct rule_lvalue	*lvalue;
    unsigned long int	val;

    
    if((token = next_token(expression)) == NULL) {
        fprintf(stderr, "Parse error: expected name of lvalue to define.\n");
        exit(1);
    }

    if(strlen(token) > (MAX_LV_NAME - 1)) {
        fprintf(stderr, "Warning: lvalue name \"%s\" is too long. max is %u:\nit will be trunkated.\n", token, (MAX_LV_NAME - 1));
    }

    if((lvalue = find_lvalue(token)) != NULL) {
        fprintf(stderr, "Warning: lvalue %s redefined: proceding with new definition.\n", token);
    } else {
        if((lvalue = (struct rule_lvalue *)malloc(sizeof(struct rule_lvalue))) == NULL) {
            fprintf(stderr, "Fatal error: %s: unable to continue.\n", strerror(errno));
            exit(1);
        }
                
        lvalue->next_lvalue = lvalue_base;
        lvalue_base = lvalue;
    }

    strncpy(lvalue->name, token, (MAX_LV_NAME - 1));

    /* get the offset */
    if((token = next_token(token)) == NULL) {
        fprintf(stderr, "Parse error: too few args for lvalue define: %s\n", lvalue->name);
        exit(1);
    }

    errno = 0;
    if((lvalue->offset = strtoul(token, &ptr, 10)) == ULONG_MAX) {
        if(errno == ERANGE) {
            fprintf(stderr, "Error: lvalue offset, %s is too large.\n", token);
            exit(1);
        }
    }

    if(*ptr != '\0') {
        fprintf(stderr, "Parse error: bad lvalue offset given: %s.\n", token);
        exit(1);
    }

    /* get the size */
    if((token = next_token(token)) == NULL) {
        fprintf(stderr, "Parse error: too few args for lvalue define: %s\n", lvalue->name);
        exit(1);
    }

    if((val = strtoul(token, &ptr, 10)) > USHRT_MAX) {
        fprintf(stderr, "Error: lvalue size, %s is too large.\n", token);
        exit(1);
    }

    if(*ptr != '\0') {
        fprintf(stderr, "Parse error: bad lvalue size given: %s.\n", token);
        exit(1);
    }

    lvalue->size = val;

    /* get the type */
    if((token = next_token(token)) == NULL) {
        fprintf(stderr, "Parse error: too few args for lvalue define: %s\n", lvalue->name);
        exit(1);
    }

    if((lvalue->type = get_type(token)) < 0) {
        fprintf(stderr, "Parse error: invalid data type, %s.\n", token);
        exit(1);
    }

    /* get the mask value */
    if((token = next_token(token)) == NULL) {
        fprintf(stderr, "Parse error: too few args for lvalue define: %s\n", lvalue->name);
        exit(1);
    }

    if((val = strtoul(token, &ptr, 10)) > UCHAR_MAX) {
        fprintf(stderr, "Error: lvalue mask must be less than 256, %s is too large.\n", token);
        exit(1);
    }

    if(*ptr != '\0') {
        fprintf(stderr, "Parse error: bad lvalue mask given: %s.\n", token);
        exit(1);
    }

    lvalue->mask = val;

    /* get the shift value */
    if((token = next_token(token)) == NULL) {
        fprintf(stderr, "Parse error: too few args for lvalue define: %s\n", lvalue->name);
        exit(1);
    }

    /* if we shift more than 7 bits for one byte, its meaningless */
    if((val = strtoul(token, &ptr, 10)) >  7) {
        fprintf(stderr, "Error: lvalue shift amount, %s is too large.\n", token);
        exit(1);
    }

    if(*ptr != '\0') {
        fprintf(stderr, "Parse error: bad lvalue shift amount given: %s.\n", token);
        exit(1);
    }

    lvalue->shift = val;

    /* that should do it... */
    return;
}


/*
 * defines a set as directed by the expression...
 * exits with error message on failure...
 */
static void define_set (char *expression)
{
    char		*token;
    rule_set_t	*set;


    if((token = next_token(expression)) == NULL) {
        fprintf(stderr, "Parse error: expected set name not found.\n");
        exit(1);
    }

    if(find_set(token) != NULL) {
        fprintf(stderr, "Warning: set %s redefined, ignoring duplicate.\n", token);
        return;
    }

    if((set = add_set(token)) == NULL) {
        fprintf(stderr, "Fatal error: %s: unable to continue.\n", strerror(errno));
        exit(1);
    }

    return;
}


/*
 * processes defines...(ie, sets, lvalues, set members...)
 * returns a pointer to the start of the next expression...
 */
static void process_define (char *expression)
{
    char	*token;


    token = find_whitespace(expression);
    *token = '\0';

    /* make sure its really a define */
    if(strcmp(expression, STR_DEFINE)) {
        fprintf(stderr, "Parse error: undefined symbol \"%s\".\n", expression);
        exit(1);
    }

    if((token = next_token(expression)) == NULL) {
        fprintf(stderr, "Parse error: expected define type.\n");
        exit(1);
    }

    if(!strcmp(token, STR_MEMBER)) {
        define_member(token);
    } else if(!strcmp(token, STR_LVALUE)) {
        define_lvalue(token);
    } else if(!strcmp(token, STR_SET)) {
        define_set(token);
    } else {
        fprintf(stderr, "Parse error: unknown define type \"%s\".\n", token);
        exit(1);
    }
    
    return;
}


/*
 * finds the lvalue struture that matches the one reffereced by
 * name...if it is not defined, NULL is returned...
 */
static struct rule_lvalue *find_lvalue (char *name)
{
    struct rule_lvalue	*lvalue = lvalue_base;

    
    if(lvalue == NULL) {
        return(NULL);
    }

    while(strcmp(name, lvalue->name)) {
        if(lvalue->next_lvalue == NULL) {
            return(NULL);
        }
        lvalue = lvalue->next_lvalue;
    }

    return(lvalue);
}


/*
 * this takes an ungrouped rule, in the form of a char
 * buffer, and parses it, creating a new rule and
 * returning a pointer to it...
 *
 * this does not fail, that is to say, it exits on failure..
 */
static struct test_expr *parse_test_expr (char **expression)
{
    unsigned long int	val;
    char				*token, *ptr;
    struct rule_lvalue	*lvalue;
    struct test_expr	*expr;


    token = skip_whitespace(*expression);
    if(*token == '\0') {
        fprintf(stderr, "Parse error: badly formed expression:\n\"%s\"\n", *expression);
        exit(1);
    }

    if((ptr = find_whitespace(token)) == NULL) {
        fprintf(stderr, "Parse error: badly formed expression:\n\"%s\"\n", *expression);
        exit(1);
    }
    *ptr = '\0';

    if((expr = (struct test_expr *)malloc(sizeof(struct test_expr))) == NULL) {
        fprintf(stderr, "Fatal error: %s: unable to continue.\n", strerror(errno));
        exit(1);
    }
    memset(expr, 0, sizeof(struct test_expr));

    /* check for the special cases */
    if(!strcmp(token, STR_ALL)) {
        expr->val = NULL;
        token += strlen(token) + 1;
        *expression = token;
        return(expr);
    } else if(!strcmp(token, STR_INSET)) {
        if((token = next_token(token)) == NULL) {
            goto error;
        }
        expr->op = IN_SET;

        if(((rule_set_t *)expr->val = find_set(token)) == NULL) {
            fprintf(stderr, "Parse error: Invalid set \"%s\".\n", token);
            exit(1);
        }
        *expression = token;
        return(expr);
    } else if(!strcmp(token, STR_NOTINSET)) {
        if((token = next_token(token)) == NULL) {
            goto error;
        }
        expr->op = NOT_IN_SET;

        if(((rule_set_t *)expr->val = find_set(token)) == NULL) {
            fprintf(stderr, "Parse error: Invalid set \"%s\".\n", token);
            exit(1);
        }
        *expression = token;
        return(expr);
    }
        

    if((lvalue = find_lvalue(token)) == NULL) {
        fprintf(stderr, "Parse error: undefined lvalue, \"%s\".\n", token);
        exit(1);
    }

    expr->offset =	lvalue->offset;
    expr->size =	lvalue->size;
    expr->mask =	lvalue->mask;

    /* get the operator */
    if((token = next_token(token)) == NULL) {
        goto error;
    }

    if(!strcmp(token, STR_ET)) {
        expr->op = EQUAL_TO;
    } else if(!strcmp(token, STR_NE)) {
        expr->op = NOT_EQUAL_TO;
    } else if(!strcmp(token, STR_GT)) {
        expr->op = GREATER_THAN;
    } else if(!strcmp(token, STR_LT)) {
        expr->op = LESS_THAN;
    } else {
        fprintf(stderr, "Parse error: invalid operator \"%s\".\n", token);
        exit(1);
    }

    /* get the rvalue */
    if((token = next_token(token)) == NULL) {
        goto error;
    }

    if((expr->val = malloc(expr->size)) == NULL) {
        fprintf(stderr, "Fatal error: %s: unable to continue.\n", strerror(errno));
        exit(1);
    }
    memset(expr->val, 0, expr->size);

    switch(lvalue->type) {
        case TN_U8:
            if((val = strtoul(token, &ptr, 10)) > UCHAR_MAX) {
                goto error;
            }
            if(token == ptr) {
                goto error;
            }
            (*(__u8 *)expr->val) = (__u8)val;
            break;
        case TN_U16:
            if((val = strtoul(token, &ptr, 10)) > USHRT_MAX) {
                goto error;
            }
            if(token == ptr) {
                goto error;
            }
            (*(__u16 *)(expr->val)) = htons((__u16)val);
            break;
        case TN_U32:
            errno = 0;
            val = strtoul(token, &ptr, 10);
            if(token == ptr) {
                goto error;
            }

            if(errno == ERANGE) {
                goto error;
            }
            (*(__u32 *)(expr->val)) = htonl((__u32)val);
            break;
        case TN_HEX:
            if((val = strtoul(token, &ptr, 16)) > UCHAR_MAX) {
                goto error;
            }
            if(token == ptr) {
                goto error;
            }
            (*(__u8 *)(expr->val)) = (__u8)val;
            break;
        case TN_STR:
            /* not yet supported */
            goto error;
            break;
        case TN_MAC:
            if(!string_to_mac(token, expr->val)) {
                goto error;
            }
            break;
        default:
            goto error;
            break;
    }
    
    if(lvalue->shift != 0) {
        expr->val[0] = expr->val[0] << lvalue->shift;
    }

    expr->high_expr = NULL;
    expr->high_op = 0;
    expr->even_expr = NULL;
    expr->even_op = 0;
    expr->low_expr = NULL;
    expr->low_op = 0;

    token += strlen(token) + 1;

    *expression = token;
    return(expr);

error:
    fprintf(stderr, "Parse error: badly formed test expression.\n");
    exit(1);
}


/*
 * returns the numeric representation of the binary
 * operator represented by the array at location buf
 * it returns 0 if it doesnt recognise the operator
 * and exits with an error message if it runs out of
 * array before that...this is because an action must
 * always follow the end of the rule test expressions
 */
static __u8 get_test_op (char **buf)
{
    __u8	operator;
    char	saved_char;
    char	*token, *ptr;


    ptr = skip_whitespace(*buf);
    if(*ptr == '\0') {
        fprintf(stderr, "Parse error: badly formed rule: missing action.\n");
        exit(1);
    }

    token = ptr;

    if((ptr = find_whitespace(ptr)) == NULL) {
        fprintf(stderr, "Parse error: badly formed rule: missing action.\n");
        exit(1);
    }

    saved_char = *ptr;
    *ptr = '\0';

    if(!strcmp(token, STR_OR)) {
        operator = OP_OR;
    } else if(!strcmp(token, STR_AND)) {
        operator = OP_AND;
    } else {
        *ptr = saved_char;
        *buf = token;
        return(0);
    }

    *ptr = saved_char;
    *buf = skip_whitespace(ptr);

    return(operator);
}


/*
 * this recursivly reads each level of parenthetical groupings
 * in the test expressions, and returns a pointer to the base 
 * of the expressions...
 */
static struct test_expr *process_expr_layer (char **expression)
{
    __u8				operator;
    unsigned int		paren_depth;
    char				*ptr;
    struct test_expr	*expr, *root;


    paren_depth = 0;
    ptr = skip_whitespace(*expression);

    /* find the start of this layer */
    while(*ptr == '(') {
        paren_depth++;
        /* its safe to assume good syntax */
        ptr = skip_whitespace(ptr + 1);
    }

#ifdef RC_DEBUG
printf("\nstarting expression layer with this:\n\"%s\".\n", ptr);
#endif 

    *expression = ptr;

    /* we can now parse the root expression for this layer */
    root = parse_test_expr(&ptr);
    expr = root;

    /* XXX - this is very sloppy all around, fix me */
    while(1) {
        if(*ptr == ')') {
            while((*ptr == ')') && (paren_depth > 0)) {
                paren_depth--;
                ptr = skip_whitespace(ptr + 1);
            }
            if((expr->low_op = get_test_op(&ptr)) == 0) {
                if(paren_depth == 0) {
                    *expression = ptr;
                    return(root);
                }
            } else {
#ifdef RC_DEBUG 
printf("adding this to lower layer:\n\"%s\".\n", ptr);
#endif
                    root->low_expr = process_expr_layer(&ptr);
            }
        } else {
            if((operator = get_test_op(&ptr)) == 0) {
                if(paren_depth == 0) {
                    *expression = ptr;
                    return(root);
                } else {
                    fprintf(stderr, "Parse error: badly formed test expression near \"%s\".\n", *expression);
                    exit(1);
                }
            }
            if(*ptr == '(') {
                expr->high_op = operator;
#ifdef RC_DEBUG 
printf("adding this to higher layer:\n\"%s\".\n", ptr);
#endif
                expr->high_expr = process_expr_layer(&ptr);
            } else {
                expr->even_op = operator;
#ifdef RC_DEBUG 
printf("adding this to even layer:\n\"%s\".\n", ptr);
#endif
                expr->even_expr = parse_test_expr(&ptr);
                expr = expr->even_expr;
            }
        }
    } 

    /* never gets here */
}


/*
 * processes and parses the test expression groupings...
 * returns a pointer to the rule base...
 * most of what this does is to check the syntax of the
 * parenthetical groupings, making sure each ( is matched...
 */
static filter_rule_t *process_test_exprs (char **expression)
{
    unsigned int		paren_open, paren_close;
    char				*ptr;
    filter_rule_t		*rule;


    if((rule = (filter_rule_t *)malloc(sizeof(filter_rule_t))) == NULL) {
        fprintf(stderr, "Fatal error: %s: unable to continue.\n", strerror(errno));
        exit(1);
    }
    memset(rule, 0, sizeof(filter_rule_t));

    paren_open = 0;
    paren_close = 0;
    ptr = *expression;
    if(*ptr == '(') {
        paren_open++;
    } else if(*ptr == ')') {
        goto error;
    }

    if(strlen(*expression) < 3) {
        fprintf(stderr, "Parse error: badly formed rule test expression \"%s\".\n", *expression);
        exit(1);
    }

    while(*(ptr + 2) != '\0') {
        if(!memcmp(ptr, " ( ", 3)) {
            paren_open++;
            ptr += 3;
        } else if(!memcmp(ptr, " ) ", 3)) {
            paren_close++;
            ptr += 3;
        }

        if(paren_close > paren_open) {
            goto error;
        }
        ptr++;
    }

    if(paren_open != paren_close) {
        goto error;
    }

    rule->test_exprs = process_expr_layer(expression);

    return(rule);

    /* i know i shouldnt do this, but im concentraiting on other things at present */
error:
    fprintf(stderr, "Parse error: unmatched parenthesis in expression:\n\"%s\".\n", *expression);
    exit(1);
}


/*
 * appends the new rule to the end of the rule set...
 */
static void add_rule (rule_set_t *set, filter_rule_t *rule)
{


    if(set->rules == NULL) {
        set->rules = rule;
    } else {
        filter_rule_t	*list = set->rules;

        while(list->next_rule != NULL) {
            list = list->next_rule;
        }
        list->next_rule = rule;
    }
}


/*
 * processes rule definitions, exits with a message on errors
 * returns a pointer to the start of the next expression...
 */
static void process_rule (char *expression)
{
    int				i;
    char			*token, *ptr;
    filter_rule_t	*rule;
    rule_set_t		*set;


    /* make sure this is really a rule */
    token = find_whitespace(expression);
    *token = '\0';

    /* make sure its really a define */
    if(strcmp(expression, STR_RULE)) {
        fprintf(stderr, "Parse error: undefined symbol \"%s\".\n", expression);
        exit(1);
    }

    if((token = next_token(token)) == NULL) {
        fprintf(stderr, "Parse error: expected rule set name.\n");
        exit(1);
    }

    if((set = find_set(token)) == NULL) {
        fprintf(stderr, "Parse error: undefined set, %s. Define this set first.\n", token);
        exit(1);
    }

    token += strlen(token) + 1;
    if((token = strchr(token, CHR_RULESTART)) ==  NULL) {
        fprintf(stderr, "Parese error: expected ':':\n\"%s\"\n", token);
        exit(1);
    }
    token++;

    rule = process_test_exprs(&token);

#ifdef RC_DEBUG
printf("action and its args looks like this: \"%s\".\n", token);
#endif

    ptr = find_whitespace(token);
    if(*ptr != '\0') {
        *ptr = '\0';    
        ptr++;
    }
    
    for(i=0;i < NUM_ACTIONS;i++) {
        if(!strcmp(token, action_list[i].action_name)) {
            rule->action_arg = action_list[i].init(ptr);
            rule->action = action_list[i].callback;
            action_list[i].used = 1;

            add_rule(set, rule);
            /* link the rule at the end of the rule list */
            return;
        }
    }

    fprintf(stderr, "Parse error: invalid action, %s.\n", token);
    exit(1);
}


/* 
 * opens the rules config file and initiates the state sets 
 * and rules structures...
 */
void load_rules_file (const char *rules_file)
{
    int				fd;				/* conf file, file descriptor */
    ssize_t			buflen;
    char			*buf, *ptr, *next;
    struct stat		st;


    /* setup the WildCard set */
    memset(&rule_sets, 0, sizeof(rule_set_t));
    strcpy(rule_sets.setname, STR_WILDCARD);
    rule_sets.rules = NULL;
    rule_sets.next_set = NULL;


    /* read in the rules file all at once */
    if(stat(rules_file, &st) < 0) {
        fprintf(stderr, "Fatal error: could not process rules file\n%s\n", strerror(errno));
        exit(1);
    }

    if((buf = (char *)malloc(st.st_size + 1)) == NULL) {
        fprintf(stderr, "Fatal error: could not process rules file\n%s\n", strerror(errno));
        exit(1);
    }

    /* NOTE: that buf will thus always be null terminated */
    buf[st.st_size] = '\0';

    if((fd = open(rules_file, O_RDONLY)) < 0) {
        fprintf(stderr, "Fatal error: could not process rules file\n%s\n", strerror(errno));
        exit(1);
    }

    ptr = buf;
    buflen = st.st_size;
    do { 
        if((buflen = read(fd, ptr, buflen)) < 0) {
            if(errno == EINTR) {
                buflen = 0;
                continue;
            }
            fprintf(stderr, "Fatal error: could not process rules file\n%s\n", strerror(errno));
            exit(1);
        }
        ptr = (ptr + buflen);
        buflen = st.st_size - buflen;
    } while(buflen != 0);
    close(fd);

    buflen = preprocessor(&buf, st.st_size + 1);

    ptr = buf;
    next = ptr;
    while((ptr = next_expression(next)) != NULL) {
#ifdef RC_DEBUG
printf("ptr = \"%s\".\n", ptr); fflush(stdout);
#endif
        next += strlen(next) + 1;
        if(!strncmp(ptr, STR_RULE, strlen(STR_RULE))) {
            process_rule(ptr);
        } else if(!strncmp(ptr, STR_DEFINE, strlen(STR_DEFINE))) {
            process_define(ptr);
        } else {
            fprintf(stderr, "Parse error: undefined symbol in expression:\n%s\n", ptr);
            exit(1);
        }
    } 

#ifdef RC_DEBUG
printf("well it didnt gpf if thats an indication that it worked...\n");
exit(0);
#endif

    /* free the lvalues */
    if(lvalue_base != NULL) {
        struct rule_lvalue	*lvalue, *next;

        lvalue = lvalue_base;
        do {
            next = lvalue->next_lvalue;
            free(lvalue);
            lvalue = next;
        } while(next != NULL);
    }

    free(buf);
    return;
}

